/**
 * Courtesy of markdown-shortcuts-plugins project(https://github.com/ngs/draft-js-markdown-shortcuts-plugin)
 */
/**
 * Courtesy of markdown-shortcuts-plugins project(https://github.com/ngs/draft-js-markdown-shortcuts-plugin)
 */

import { EditorState } from 'draft-js';

const changeCurrentBlockType = ( editorState, type, text, blockMetadata = {} ) => {
  const currentContent = editorState.getCurrentContent();
  const selection = editorState.getSelection();
  const key = selection.getStartKey();
  const blockMap = currentContent.getBlockMap();
  const block = blockMap.get( key );
  const data = block.getData().merge( blockMetadata );
  const newBlock = block.merge( { type, data, text: text || '' } );
  const newSelection = selection.merge( {
    anchorOffset: 0,
    focusOffset: 0,
  } );
  const newContentState = currentContent.merge( {
    blockMap: blockMap.set( key, newBlock ),
    selectionAfter: newSelection,
  } );
  return EditorState.push(
    editorState,
    newContentState,
    'change-block-type'
  );
};

export default changeCurrentBlockType;
